%global pkg mellanox-rdma
%global kernel 5.10.134-16.an8
%define pkg_version 5.4_3.1.0
%define anolis_release 1

%global kernel_release() $(make -C %{1} kernelrelease | grep -v make | tail -1)

%{!?configure_options: %global configure_options --with-core-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod --with-mlx5-mod --with-mlxfw-mod --with-ipoib-mod --with-isert-mod --with-iser-mod --with-srp-mod --with-scsi_transport_srp-mod}
%{!?K_SRC: %global K_SRC /lib/modules/%{kernel}.%{_arch}/build}
%{!?KERNEL_SOURCES: %global KERNEL_SOURCES /lib/modules/%{kernel}.%{_arch}/source}
%global kernel_source() %{K_SRC}

%global flavors_to_build default

Summary: Infiniband HCA Driver
Name: kmod-%{pkg}
Version: %(echo %{kernel} | sed -E 's/-/~/g; s/\.(el|al|alios|an)[0-9]+$//g')
Release: %{pkg_version}~%{anolis_release}%{?dist}
License: GPLv2
Url: http://www.mellanox.com/
Group: System Environment/Base
Patch0: source-git.patch
ExclusiveArch: x86_64
BuildRoot: %{?build_root:%{build_root}}%{!?build_root:/var/tmp/OFED}
Vendor: Mellanox Technologies
Obsoletes: kernel-ib
Obsoletes: mlnx-en
Obsoletes: mlnx_en
Obsoletes: mlnx-en-utils
Obsoletes: kmod-mlnx-en
Obsoletes: mlnx-en-kmp-default
Obsoletes: mlnx-en-kmp-xen
Obsoletes: mlnx-en-kmp-trace
Obsoletes: mlnx-en-doc
Obsoletes: mlnx-en-debuginfo
Obsoletes: mlnx-en-sources
Requires: mlnx-tools >= 5.2.0
Requires: coreutils
Requires: pciutils
Requires: grep
Requires: procps
Requires: module-init-tools
Requires: lsof
Requires: kernel
Requires: patch
Requires: make
Requires: kernel-core-uname-r >= %{kernel}.%{_arch}
Requires: kernel-modules-extra-uname-r >= %{kernel}.%{_arch}
Requires: kernel-modules-internal-uname-r >= %{kernel}.%{_arch}
Requires: kernel-modules-uname-r >= %{kernel}.%{_arch}
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

BuildRequires:    kernel-devel   = %{kernel}
BuildRequires:    kernel-headers = %{kernel}
BuildRequires:    kernel-core = %{kernel}
BuildRequires: /usr/bin/perl
BuildRequires: autoconf
BuildRequires: automake

%description 
InfiniBand "verbs", Access Layer  and ULPs.
Utilities rpm.
The driver sources are located at: http://www.mellanox.com/downloads/ofed/mlnx-ofa_kernel-5.4-3.1.0.tgz

%global install_mod_dir extra/%{name}

%prep
%autosetup -p1 -c -T
mv src/ source/
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
export INSTALL_MOD_DIR=%{install_mod_dir}
export CONF_OPTIONS="%{configure_options}"
export LIB_MOD_DIR=/lib/modules/$kernel/$INSTALL_MOD_DIR

for flavor in %flavors_to_build; do
    export KSRC=%{kernel_source $flavor}
    export kernel=%{kernel_release $KSRC}
    export LIB_MOD_DIR=/lib/modules/$kernel/$INSTALL_MOD_DIR
    rm -rf obj/$flavor
    cp -a source obj/$flavor
    cd $PWD/obj/$flavor
	autoreconf -vif ./compat
    find compat -type f -exec touch -t 200012201010 '{}' \; || true
    ./configure --build-dummy-mods --prefix=%{_prefix} --kernel-version $kernel --kernel-sources $KSRC --modules-dir $LIB_MOD_DIR $CONF_OPTIONS %{?_smp_mflags}
    patch -p2 < 0002-update-driver-version.patch
	patch -p2 < 0003-bump-up-link-msg-level.patch
	patch -p2 < 0006-add-rdmacm-conn-parameters.patch
	patch -p2 < 0010-skip-non-rdma-port.patch
	patch -p2 < 0012-canceling-nic-rename.patch
	make %{?_smp_mflags} kernel
    make build_py_scripts
    cd -
done

%install
%{__install} -d %{buildroot}%{_sysconfdir}/udev/
%define _unpackaged_files_terminate_build 0
export RECORD_PY_FILES=1
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=%{install_mod_dir}
export NAME=%{name}
export VERSION=%{version}
export PREFIX=%{_prefix}
for flavor in %flavors_to_build; do 
	export KSRC=%{kernel_source $flavor}
	export kernel=%{kernel_release $KSRC}
	cd $PWD/obj/$flavor
	make install_modules KERNELRELEASE=$kernel
	# install script and configuration files
	make install_scripts
	mkdir -p %{_builddir}/src/$NAME/$flavor
	cp -ar include/ %{_builddir}/src/$NAME/$flavor
	cp -ar config* %{_builddir}/src/$NAME/$flavor
	cp -ar compat*  %{_builddir}/src/$NAME/$flavor
	cp -ar ofed_scripts %{_builddir}/src/$NAME/$flavor

	modsyms=`find . -name Module.symvers -o -name Modules.symvers`
	if [ -n "$modsyms" ]; then
		for modsym in $modsyms
		do
			cat $modsym >> %{_builddir}/src/$NAME/$flavor/Module.symvers
		done
	else
		./ofed_scripts/create_Module.symvers.sh
		cp ./Module.symvers %{_builddir}/src/$NAME/$flavor/Module.symvers
	fi
	# Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
	cd -
done

# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} \( -type f -name '*.ko' -o -name '*ko.gz' \) -exec %{__chmod} u+x \{\} \;

%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
for module in `find %{buildroot}/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
ko_name=${module##*/}
mod_name=${ko_name/.ko*/}
mod_path=${module/*%{name}}
mod_path=${mod_path/\/${ko_name}}
echo "override ${mod_name} * weak-updates/%{name}${mod_path}" >> %{buildroot}%{_sysconfdir}/depmod.d/%{name}-${mod_name}.conf
echo "override ${mod_name} * extra/%{name}${mod_path}" >> %{buildroot}%{_sysconfdir}/depmod.d/%{name}-${mod_name}.conf
done

INFO=${RPM_BUILD_ROOT}/etc/infiniband/info
/bin/rm -f ${INFO}
mkdir -p ${RPM_BUILD_ROOT}/etc/infiniband
touch ${INFO}

cat >> ${INFO} << EOFINFO
#!/bin/bash

echo prefix=%{_prefix}
echo Kernel=%{kernel}.%{_arch}
echo
echo "Configure options: %{configure_options}"
echo
EOFINFO

chmod +x ${INFO} > /dev/null 2>&1

install -d %{buildroot}%{_unitdir}
install -d %{buildroot}/etc/systemd/system
install -m 0644 %{_builddir}/$NAME-$VERSION/source/ofed_scripts/openibd.service %{buildroot}%{_unitdir}
install -m 0644 %{_builddir}/$NAME-$VERSION/source/ofed_scripts/mlnx_interface_mgr\@.service %{buildroot}/etc/systemd/system
install -m 0644 %{_builddir}/$NAME-$VERSION/obj/default/Module.symvers %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/%{name}

install -d %{buildroot}/bin
install -m 0755 %{_builddir}/$NAME-$VERSION/source/ofed_scripts/mlnx_conf_mgr.sh %{buildroot}/bin/
%if "%{WINDRIVER}" == "0" && "%{BLUENIX}" == "0"
install -m 0755 %{_builddir}/$NAME-$VERSION/source/ofed_scripts/mlnx_interface_mgr.sh %{buildroot}/bin/
%else
# Wind River and Mellanox Bluenix are rpm based, however, interfaces management is done in Debian style
install -d %{buildroot}/usr/sbin
install -m 0755 %{_builddir}/$NAME-$VERSION/source/ofed_scripts/mlnx_interface_mgr_deb.sh %{buildroot}/bin/mlnx_interface_mgr.sh
install -m 0755 %{_builddir}/$NAME-$VERSION/source/ofed_scripts/net-interfaces %{buildroot}/usr/sbin
%endif

# Install ibroute utilities
# TBD: move these utilities into standalone package
install -d %{buildroot}%{_sbindir}

%post -n %{name}
depmod -a %{kernel}.%{_arch}
dracut -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}

/usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
cat /proc/sys/kernel/random/boot_id 2>/dev/null | sed -e 's/-//g' > /var/run/openibd.bootid || true
test -s /var/run/openibd.bootid || echo manual > /var/run/openibd.bootid || true

# Comment core modules loading hack
if [ -e /etc/modprobe.conf.dist ]; then
	sed -i -r -e 's/^(\s*install ib_core.*)/#MLX# \1/' /etc/modprobe.conf.dist
	sed -i -r -e 's/^(\s*alias ib.*)/#MLX# \1/' /etc/modprobe.conf.dist
fi
# END of post

for module in `find /lib/modules/%{kernel}.%{_arch}/extra/%{name}/drivers -name '*.ko' -o -name '*.ko.gz' | sort`
do
echo "$module" | /usr/sbin/weak-modules --no-initramfs --add-modules
done

%preun -n %{name}
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/%{name}/drivers -name '*.ko' -o -name '*.ko.gz' | sort`
do
echo "$module" >> /var/run/rpm-%{pkg}-modules.list
done

%postun -n %{name}
/usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
depmod -a %{kernel}.%{_arch}
dracut -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}

# Uncomment core modules loading hack
if [ -e /etc/modprobe.conf.dist ]; then
	sed -i -r -e 's/^#MLX# (.*)/\1/' /etc/modprobe.conf.dist
fi

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

#end of post uninstall

%files -n %{name}
%license licenses
%dir /etc/infiniband
%config(noreplace) /etc/infiniband/openib.conf
%config(noreplace) /etc/infiniband/mlx5.conf
/etc/infiniband/info
/etc/infiniband/vf-net-link-name.sh
/etc/init.d/openibd
%{_unitdir}/openibd.service
/etc/systemd/system/mlnx_interface_mgr@.service
/lib/udev/sf-rep-netdev-rename
/lib/udev/auxdev-sf-netdev-rename
/usr/sbin/setup_mr_cache.sh
/usr/sbin/odp_stat.sh
%_datadir/mlnx_ofed/mlnx_bf_assign_ct_cores.sh
%config(noreplace) /etc/modprobe.d/mlnx.conf
%config(noreplace) /etc/modprobe.d/mlnx-bf.conf
%{_sbindir}/*
/lib/udev/rules.d/83-mlnx-sf-name.rules
/lib/udev/rules.d/82-net-setup-link.rules
/lib/udev/rules.d/90-ib.rules
/bin/mlnx_interface_mgr.sh
/bin/mlnx_conf_mgr.sh
%{_sbindir}/ibdev2netdev

/lib/modules/%{kernel}.%{_arch}/%{install_mod_dir}/
%config(noreplace) %{_sysconfdir}/depmod.d/%{name}-*.conf

%changelog
* Fri Oct 20 2023 mengxiangjun.mx <mengxiangjun.mxj@alibaba-inc.com> - 5.4.3.1.0
- add mellaonx driver 5.4 base code
